//cut off what's after the floats using int
//put fonts in the particles class
//render the name as numbers, using the opacity for the size


import oscP5.*;
import netP5.*;
 
OscP5 oscP5;

NetAddress myRemoteLocation; 
String readout;
String chimesReadout;
PFont f;

//some items to keep track of the ends of words
boolean firstPauseWind;
boolean newWord;
boolean firstPauseChimes;
int wordTimer;

//visuals
int backOpacity;
ParticleSystem lowParticles;
ParticleSystem midParticles;
ParticleSystem topParticles;

int trippyRadius;


void setup() {
  size(800,600);
  background(0);
  smooth();
  
  //set up particle systems for visuals
  lowParticles = new ParticleSystem(); 
  println("new particle system created");
  midParticles = new ParticleSystem(); 
  topParticles = new ParticleSystem(); 
  
  trippyRadius = 0;

  //setup the remote address
  oscP5 = new OscP5(this,12000);
  myRemoteLocation = new NetAddress("127.0.0.1",12001);
  
 //get the inputs from PD 
  oscP5.plug(this,"wind","/wind"); 
  oscP5.plug(this,"lowChimes","/lowChimes"); 
  oscP5.plug(this,"midChimes","/midChimes"); 
  oscP5.plug(this,"highChimes","/highChimes"); 
  
  //create the string readout upstairs
  readout = " ";
  chimesReadout = " ";
  f = createFont("Arial",12,true);
  firstPauseWind = false;
  firstPauseChimes = false;
  newWord = true;
  wordTimer = 0;
  backOpacity = 0;
  
  background(0);
  
}

void draw() {
 
 background(0);
  
  //Now draw the wind
  fill(255, backOpacity);
   rect(0, 75, width, height-75);

  //now draw the sparkles!
  topParticles.run(); 
  lowParticles.run(); 
  midParticles.run(); 
  
    //now write out the top strings!
  noStroke();
  fill(0, 150);
  rect (0,0, width, 75);
  fill(130);
  textFont(f,35);
  textAlign(RIGHT);
  text(readout,width, 35);
  text(chimesReadout,width, 70);
  
  //make sure the strings aren't too long
  if (readout.length() > 50){          //if the string is getting too long, cut it
    readout = readout.substring(readout.length()- 50, readout.length());
  }
  
  if (chimesReadout.length() > 70){          //if the string is getting too long, cut it
    chimesReadout = chimesReadout.substring(chimesReadout.length()- 70, chimesReadout.length());
  }
  
  //put spaces into the ChimesReadout!
  if ((wordTimer > 20) && (firstPauseChimes == true)) {
    addString("  ");
    firstPauseChimes = false;
  }
 
   wordTimer++;
  
  //now, behind all that, let's draw a trippy lookin circle!
  
 
    fill(trippyRadius, trippyRadius, 255, 40);
    ellipse(width/2, height/2, trippyRadius, trippyRadius);
    
    fill(trippyRadius, trippyRadius-200, 255, 40);
    ellipse(width/2, height/2, constrain(trippyRadius-200, 0, width-200), constrain(trippyRadius-200, 0, width-200));
    
    fill(149, trippyRadius-400, 255, 40);
    ellipse(width/2, height/2, constrain(trippyRadius-400, 0, width-200), constrain(trippyRadius-400, 0, width-400));
    
    fill(149, trippyRadius-600, 255, 40);
    ellipse(width/2-150, height/2, constrain(trippyRadius-400, 0, width-200), constrain(trippyRadius-400, 0, width-400));
    
    fill(149, trippyRadius-600, 255, 40);
    ellipse(width/2+150, height/2, constrain(trippyRadius-400, 0, width-200), constrain(trippyRadius-400, 0, width-400));
    
     fill(trippyRadius, trippyRadius, 255, 40);
    ellipse(width/2, height/2, constrain(trippyRadius-600, 0, width-200), constrain(trippyRadius-500, 0, width-400));
  

  trippyRadius = constrain(trippyRadius-4, 0, width);

} //end run


void wind(float number) {  //this would be best changing the color of the background
  
  if (backOpacity > map(number, 0, .5, 0, 200)) {
  backOpacity = constrain(backOpacity-2, 0, 200);
  }
  else { backOpacity = constrain(backOpacity + 2, 0, 200); }
  
   //fill(map(number, 0, .5, 0, 255)); 
   
   //if number is greater than 1 but less than 4, s
   if ((number <= .06)&& (firstPauseWind == true))  {
     readout = readout + " ";
     firstPauseWind = false;    //we can't have another space
     newWord = true;  //but the next item begins with an s
   }
   
   if (newWord == true){
     if ((number >.06) && (number <.3))  {
       //println ("s" + newWord);
       readout = readout + " s" ;
       firstPauseWind = true;  //we could have another space
       newWord = false;  //but the next item can't be an s
     }
     
     //if readout number is greater than 4, S
     if (number >=.3) {
       //println("S" + newWord);
       readout = readout + " S" ;
       firstPauseWind = true;
       newWord = false;
     }
   }//end new word== true
   
   
   if (newWord == false) {
      //println("h" + newWord);
     if ((number >.06) && (number <.3))  {
       readout = readout + "h" ;
       firstPauseWind = true;
     }
     
     //if readout number is greater than 4, S
     if (number >=.3) {
        //println("H" + newWord);
       readout = readout + "H";
       firstPauseWind = true;
     }
   }    //end elseif
   
   
   //readout = str(number) + readout;
   
   //println (number);
  //rect(0,0,100, 100); 
}  //end draw

void lowChimes(float number) {  //the actual gust of the program
  //println("lows triggered");
  //println (number);
  //fill(map(number, 30, 100, 0, 255)); 
  //fill(255);
  //rect(100,0,100, 100); 
  
  trippyRadius=trippyRadius+100;
  
  lowParticles.addParticle(str(number), 90, 0, 0, 255);  //string, start size, color rgb
   println("new particle added, strength " + number);
  
  if (number < 80) {
    addString("du");
    
  }
  
  else if (number <90) {
    
    addString("ba"); 
  }
  
  else {
    addString("bee");
  }
}

void midChimes(float number) {  //the actual gust of the program 

trippyRadius=trippyRadius+50;

 midParticles.addParticle(str(number), 50, 141, 173, 17);  //string, start size, color rgb
   println("new mid particle added, strength " + number);
  //println(number);
     
   if (number < 62) {
    addString("kso");
  }
  
  else if (number <70) {
    
    addString("tsu");
  }
  
  else {
    addString("kai");
  }
}

void highChimes(String message) {  //the actual gist of the program

trippyRadius=trippyRadius+8;

topParticles.addParticle(str(1), 20, 255, 255, 188);  //string, start size, color rgb
   println("new top particle added");

   if (random(1, 3) >= 2) {
     addString("tee");
   }
   else {
     addString("ta");
   }
}

void addString (String sound) {
  chimesReadout = chimesReadout + sound ;
  wordTimer = 0;  //set wordtimer back to 0
  firstPauseChimes = true;
  
}

// incoming osc message are forwarded to the oscEvent method.
void oscEvent(OscMessage theOscMessage) {
  //theOscMessage.print();
}
